#
# This script was badly written by Michel Arboi <arboi@algoriel.fr>
# and fixed by Renaud Deraison, as usual :)
#
# See the Nessus Scripts License for details
#

if(description)
{
 script_id(10621);
 script_version ("$Revision: 1.8 $");
 name["english"] = "HTTP login";
 name["francais"] = "Login HTTP";
 
 script_name(english:name["english"],
            francais:name["francais"]);
 
 desc["english"] = "
Provide the username/password for the HTTP server(s).
This plugin does not do any security check.

Risk factor : None";

 desc["francais"] = "
Fournir le nom_d_utilisateur/mot_de_passe pour le(s) serveur(s) HTTP.
Ce plugin ne fait aucun test de securit";

 script_description(english:desc["english"],
                   francais:desc["francais"]);
 
 summary["english"] = "HTTP login/password";
 summary["francais"] = "nom/mot_de_passe HTTP";
 script_summary(english:summary["english"],
               francais:summary["francais"]);
 
 script_category(ACT_GATHER_INFO);
 
 script_copyright(english:"This script is Copyright (C) 2001 Michel Arboi");
 family["english"] = "Misc.";
 family["francais"] = "Divers";
 script_family(english:family["english"], francais:"Divers");
 
 script_add_preference(name:"HTTP user name :", type:"entry", value:"");
 script_add_preference(name:"HTTP password (sent in clear) :", type:"password", value:"");

 exit(0);
}

#
# base64 conversion was written by Renaud Deraison.
#
__base64_code = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
function base64_code(c)
{
 return(__base64_code[c]);
}

function pow2(x)
{
 __ret = 1;
 while(x)
  {
  __ret = __ret * 2;
  x = x  - 1;
  }
 return(__ret);
}

function base64(str)
{
 len = strlen(str);
 i = 0;
 ret = "";
 char_count = 0;
 _bits = 0;
 while(i < len)
 {
  _bits = _bits + ord(str[i]);
  char_count = char_count + 1;
  if(char_count == 3)
  {
    val = _bits / 262144;
    ret = string(ret, base64_code(c:val));
    val = _bits / 4096;
    val = val & 0x3F;
    ret = string(ret, base64_code(c:val));
    val = _bits / 64;
    val = val & 0x3F;
    ret = string(ret, base64_code(c:val));
    val = _bits & 0x3F;
    ret = string(ret, base64_code(c:val));
    char_count = 0;
    _bits = 0;
 }
 else {
       _bits = _bits * 256;
       }
 i = i + 1;
 }


 if(!(char_count == 0))
 {
  cnt = char_count * 8;
  mul = 16;
  mul = mul - cnt;
  mul = pow2(x:mul);
  _bits = _bits * mul;
  val = _bits / 262144;
  ret = string(ret, base64_code(c:val));
  val = _bits / 4096;
  val = val & 0x3F;
  ret = string(ret, base64_code(c:val));
 if(char_count == 1)
 { 
  ret = string(ret, "==");
 }
 else
 {
   val = _bits / 64;
   val = val & 0x3F;
   ret = string(ret, base64_code(c:val), "=");
  }
 }
 return(ret);
}

  
http_username = script_get_preference("HTTP user name :");
http_password = script_get_preference("HTTP password (sent in clear) :");

if (http_username)
{
 set_kb_item(name:"http/username", value:http_username);
 set_kb_item(name:"http/password", value:http_password);

 userpass = string(http_username, ":",http_password);
 #display(userpass);
 userpass64 = base64(str:userpass);
 authstr = "Authorization: Basic " + userpass64;
 set_kb_item(name:"http/auth", value:authstr);
}
